<?php
/**
 * Created by PhpStorm.
 * User: wanderleijunior
 * Date: 21/10/20
 * Time: 11:45
 */

namespace Repositories;

use Util\InstanceProvider;
use Util\Utilities;

class Logacesso
{
    /**
     * @param $cdoperador
     * @param $currentdate
     * @param $dssistema
     * @param $nrorg
     * @throws \Exception
     */
    public function create($cdoperador, $dssistema, $nrorg)
    {
        $dateTimeFormat = 'DD/MM/YYYY HH24:MI:SS';
        $query = <<<SQL
            INSERT INTO LOGACESSO
                        (CDOPERADOR, DTHRACESSO, DSSISTEMA, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
                 VALUES (:CDOPERADOR, TO_DATE(:NOW,'$dateTimeFormat'), :DSSISTEMA, :NRORG, TO_DATE(:NOW,'$dateTimeFormat'), TO_DATE(:NOW,'$dateTimeFormat'), :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU)
SQL;
            $params = array(
                "CDOPERADOR" => $cdoperador,
                "DSSISTEMA" => $dssistema,
                "NRORG" => $nrorg,
                "NRORGINCLUSAO" => $nrorg,
                "CDOPERINCLUSAO" => $cdoperador,
                "NRORGULTATU"  => $nrorg,
                "NOW"     => Utilities::getCurrentDateTimeString(),
                "CDOPERULTATU" => $cdoperador
            );

        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

            $std = $entityManager->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }

    public function findByOperator($cdoperador, $nrorg)
    {
        $query = <<<SQL
                  SELECT L.CDOPERADOR AS "CDOPERADOR", L.DTHRACESSO AS "DTHRACESSO", L.DSSISTEMA AS "DSSISTEMA", L.IDATIVO AS "IDATIVO", L.IDIMPLOGACESSO AS "IDIMPLOGACESSO"
                    FROM LOGACESSO L
                   WHERE L.NRORG = :NRORG
                     AND L.CDOPERADOR = :CDOPERADOR
SQL;

        $params = array('NRORG' => $nrorg, 'CDOPERADOR' => $cdoperador);
        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
            $data = $entityManager->getConnection()->fetchAll($query, $params);
            return empty($data) ? $data : $data[0];
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }

    public function update($cdoperador, $nrorg)
    {
        $dateTimeFormat = 'DD/MM/YYYY HH24:MI:SS';
        $query = <<<SQL
                  UPDATE LOGACESSO
                     SET DTHRACESSO     = TO_DATE(:NOW,'$dateTimeFormat'),
                         NRORGULTATU    = :NRORG,
                         DTULTATU       = TO_DATE(:NOW,'$dateTimeFormat'),
                         CDOPERULTATU   = :CDOPERADOR
                   WHERE CDOPERADOR     = :CDOPERADOR
                     AND NRORG          = :NRORG
SQL;

        $params = array(
            'CDOPERADOR' => $cdoperador,
            'NOW'        => Utilities::getCurrentDateTimeString(),
            'NRORG' => $nrorg
        );
        try {
            $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
            $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
            $entityManager->getConnection()->executeQuery($query, $params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
}